//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property  indicator_buffers 3
#property  indicator_color1  DimGray
#property  indicator_color2  DeepSkyBlue
#property  indicator_color3  PaleVioletRed
#property  indicator_style1  STYLE_DOT

//
//
//
//
//

extern int  ChannelPeriod = 100;
extern bool UseHighLow    = false;
extern bool HideHistory   = true;

//
//
//
//
//

double bufferUp[];
double bufferDn[];
double bufferMi[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,bufferMi);
   SetIndexBuffer(1,bufferUp);
   SetIndexBuffer(2,bufferDn);
   SetIndexBuffer(3,prices);
         IndicatorShortName("regression channel ("+ChannelPeriod+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i,k;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      prices[i] = Close[i];
      double slope;
      double value = iLRValue(slope,ChannelPeriod,i);
         
         //
         //
         //
         //
         //
         
         double high  = 0;
         double low   = 0;
         
            for (k=0; k<ChannelPeriod; k++)
            {
               bufferMi[i+k]=value-k*slope;
               if (UseHighLow)
               {
                  high = MathMax(high,High[i+k]-bufferMi[i+k]);
                  low  = MathMax(low ,bufferMi[i+k]-Low[i+k]);
               }
               else
               {
                  high = MathMax(high,Close[i+k]-bufferMi[i+k]);
                  low  = MathMax(low ,bufferMi[i+k]-Close[i+k]);
               }
            }
            for (k=0; k<ChannelPeriod; k++)
            {
               bufferDn[i+k]=bufferMi[i+k]-MathMax(high,low);
               bufferUp[i+k]=bufferMi[i+k]+MathMax(high,low);
            }
   }
   
   //
   //
   //
   //
   //
 
   int drawBegin = 0; if (HideHistory) drawBegin = Bars-ChannelPeriod;
         for (k=0; k<3; k++) SetIndexDrawBegin(k,drawBegin);
   return(0);
}


//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lr.period=0;
double lr.sumX;
double lr.sumXSqr;
double lr.divisor;

//
//
//
//
//

double iLRValue(double& LinearRegSlope, int len, int shift)
{
   double LinearRegValue;
   double Intercept;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lr.period != len)
   {
      lr.period  = len;
      lr.sumX    = lr.period * (lr.period-1) / 2;
      lr.sumXSqr = lr.period * (lr.period-1) * (2 * lr.period - 1) / 6;
      lr.divisor = MathPow(lr.sumX,2) - lr.period * lr.sumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lr.period; i++)
   {
      double price = prices[i+shift];
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lr.divisor != 0 ) 
         	LinearRegSlope = (lr.period * SumXY - lr.sumX * SumY)/lr.divisor;
   else     LinearRegSlope = 0; 
   
   //
   //
   //
   //
   //
   
   Intercept      = (SumY - LinearRegSlope * lr.sumX) / lr.period ;
	LinearRegValue = Intercept  + LinearRegSlope * (lr.period-1);
   return(LinearRegValue);
}

